/******************************************************************************
 * This file was generated by langium-cli 0.2.0.
 * DO NOT EDIT MANUALLY!
 ******************************************************************************/

/* eslint-disable @typescript-eslint/array-type */
/* eslint-disable @typescript-eslint/no-empty-interface */
import { AstNode, AstReflection, Reference, isAstNode } from 'langium';

export interface ImperialUnit extends AstNode {
    unit: 'POUNDS' | 'CUPS' | 'OZ'
}

export const ImperialUnit = 'ImperialUnit';

export function isImperialUnit(item: unknown): item is ImperialUnit {
    return reflection.isInstance(item, ImperialUnit);
}

export interface Ingredient extends AstNode {
    readonly $container: Model;
    amount: number
    name: string
    unit: MetricUnit
}

export const Ingredient = 'Ingredient';

export function isIngredient(item: unknown): item is Ingredient {
    return reflection.isInstance(item, Ingredient);
}

export interface MetricUnit extends AstNode {
    readonly $container: Ingredient | StepAddIngredientAmountToTool;
    unit: 'ML' | 'G' | 'KG' | 'L'
}

export const MetricUnit = 'MetricUnit';

export function isMetricUnit(item: unknown): item is MetricUnit {
    return reflection.isInstance(item, MetricUnit);
}

export interface Model extends AstNode {
    ingredients: Array<Ingredient>
    steps: Array<Steps>
    tools: Array<Tool>
}

export const Model = 'Model';

export function isModel(item: unknown): item is Model {
    return reflection.isInstance(item, Model);
}

export interface NewStep extends AstNode {
    readonly $container: Steps;
}

export const NewStep = 'NewStep';

export function isNewStep(item: unknown): item is NewStep {
    return reflection.isInstance(item, NewStep);
}

export interface Steps extends AstNode {
    readonly $container: Model;
    steps: Array<NewStep>
}

export const Steps = 'Steps';

export function isSteps(item: unknown): item is Steps {
    return reflection.isInstance(item, Steps);
}

export interface TemperatureSystem extends AstNode {
    readonly $container: StepSetTemperatureToolToAmountDegree;
    system: 'CELSIUS' | 'FAHRENHEIT'
}

export const TemperatureSystem = 'TemperatureSystem';

export function isTemperatureSystem(item: unknown): item is TemperatureSystem {
    return reflection.isInstance(item, TemperatureSystem);
}

export interface TimeUnit extends AstNode {
    readonly $container: StepWaitToolForAmountTime;
    time: 'SECONDS' | 'MINUTES' | 'HOURS'
}

export const TimeUnit = 'TimeUnit';

export function isTimeUnit(item: unknown): item is TimeUnit {
    return reflection.isInstance(item, TimeUnit);
}

export interface Tool extends AstNode {
    readonly $container: Model;
    name: string
}

export const Tool = 'Tool';

export function isTool(item: unknown): item is Tool {
    return reflection.isInstance(item, Tool);
}

export interface UniversalCookingUnit extends AstNode {
    unit: 'TBSP' | 'TSP' | 'PC'
}

export const UniversalCookingUnit = 'UniversalCookingUnit';

export function isUniversalCookingUnit(item: unknown): item is UniversalCookingUnit {
    return reflection.isInstance(item, UniversalCookingUnit);
}

export interface StepAddFromToolAllToTool extends NewStep {
    fromTool: Reference<Tool>
    toTool: Reference<Tool>
}

export const StepAddFromToolAllToTool = 'StepAddFromToolAllToTool';

export function isStepAddFromToolAllToTool(item: unknown): item is StepAddFromToolAllToTool {
    return reflection.isInstance(item, StepAddFromToolAllToTool);
}

export interface StepAddIngredientAllToTool extends NewStep {
    ingredient: Reference<Ingredient>
    tool: Reference<Tool>
}

export const StepAddIngredientAllToTool = 'StepAddIngredientAllToTool';

export function isStepAddIngredientAllToTool(item: unknown): item is StepAddIngredientAllToTool {
    return reflection.isInstance(item, StepAddIngredientAllToTool);
}

export interface StepAddIngredientAmountToTool extends NewStep {
    amount: number
    ingredient: Reference<Ingredient>
    tool: Reference<Tool>
    unit: MetricUnit
}

export const StepAddIngredientAmountToTool = 'StepAddIngredientAmountToTool';

export function isStepAddIngredientAmountToTool(item: unknown): item is StepAddIngredientAmountToTool {
    return reflection.isInstance(item, StepAddIngredientAmountToTool);
}

export interface StepMixTool extends NewStep {
    tool: Reference<Tool>
}

export const StepMixTool = 'StepMixTool';

export function isStepMixTool(item: unknown): item is StepMixTool {
    return reflection.isInstance(item, StepMixTool);
}

export interface StepSetTemperatureToolToAmountDegree extends NewStep {
    amount: number
    temperatureSystem: TemperatureSystem
    tool: Reference<Tool>
}

export const StepSetTemperatureToolToAmountDegree = 'StepSetTemperatureToolToAmountDegree';

export function isStepSetTemperatureToolToAmountDegree(item: unknown): item is StepSetTemperatureToolToAmountDegree {
    return reflection.isInstance(item, StepSetTemperatureToolToAmountDegree);
}

export interface StepWaitToolForAmountTime extends NewStep {
    amount: number
    time: TimeUnit
    tool: Reference<Tool>
}

export const StepWaitToolForAmountTime = 'StepWaitToolForAmountTime';

export function isStepWaitToolForAmountTime(item: unknown): item is StepWaitToolForAmountTime {
    return reflection.isInstance(item, StepWaitToolForAmountTime);
}

export type LangiumNameTestAstType = 'ImperialUnit' | 'Ingredient' | 'MetricUnit' | 'Model' | 'NewStep' | 'Steps' | 'TemperatureSystem' | 'TimeUnit' | 'Tool' | 'UniversalCookingUnit' | 'StepAddFromToolAllToTool' | 'StepAddIngredientAllToTool' | 'StepAddIngredientAmountToTool' | 'StepMixTool' | 'StepSetTemperatureToolToAmountDegree' | 'StepWaitToolForAmountTime';

export type LangiumNameTestAstReference = 'StepAddFromToolAllToTool:fromTool' | 'StepAddFromToolAllToTool:toTool' | 'StepAddIngredientAllToTool:ingredient' | 'StepAddIngredientAllToTool:tool' | 'StepAddIngredientAmountToTool:ingredient' | 'StepAddIngredientAmountToTool:tool' | 'StepMixTool:tool' | 'StepSetTemperatureToolToAmountDegree:tool' | 'StepWaitToolForAmountTime:tool';

export class LangiumNameTestAstReflection implements AstReflection {

    getAllTypes(): string[] {
        return ['ImperialUnit', 'Ingredient', 'MetricUnit', 'Model', 'NewStep', 'Steps', 'TemperatureSystem', 'TimeUnit', 'Tool', 'UniversalCookingUnit', 'StepAddFromToolAllToTool', 'StepAddIngredientAllToTool', 'StepAddIngredientAmountToTool', 'StepMixTool', 'StepSetTemperatureToolToAmountDegree', 'StepWaitToolForAmountTime'];
    }

    isInstance(node: unknown, type: string): boolean {
        return isAstNode(node) && this.isSubtype(node.$type, type);
    }

    isSubtype(subtype: string, supertype: string): boolean {
        if (subtype === supertype) {
            return true;
        }
        switch (subtype) {
            case StepAddFromToolAllToTool:
            case StepAddIngredientAllToTool:
            case StepAddIngredientAmountToTool:
            case StepMixTool:
            case StepSetTemperatureToolToAmountDegree:
            case StepWaitToolForAmountTime: {
                return this.isSubtype(NewStep, supertype);
            }
            default: {
                return false;
            }
        }
    }

    getReferenceType(referenceId: LangiumNameTestAstReference): string {
        switch (referenceId) {
            case 'StepAddFromToolAllToTool:fromTool': {
                return Tool;
            }
            case 'StepAddFromToolAllToTool:toTool': {
                return Tool;
            }
            case 'StepAddIngredientAllToTool:ingredient': {
                return Ingredient;
            }
            case 'StepAddIngredientAllToTool:tool': {
                return Tool;
            }
            case 'StepAddIngredientAmountToTool:ingredient': {
                return Ingredient;
            }
            case 'StepAddIngredientAmountToTool:tool': {
                return Tool;
            }
            case 'StepMixTool:tool': {
                return Tool;
            }
            case 'StepSetTemperatureToolToAmountDegree:tool': {
                return Tool;
            }
            case 'StepWaitToolForAmountTime:tool': {
                return Tool;
            }
            default: {
                throw new Error(`${referenceId} is not a valid reference id.`);
            }
        }
    }
}

export const reflection = new LangiumNameTestAstReflection();
